package engine

import "github.com/dop251/goja"

type RegisterFunc func(msf ModuleSetFunc)
type ModuleSetFunc func(name string, value interface{})

type ModuleContext struct {
	engine       *Engine
	registerFunc RegisterFunc
}

type IModule interface {
	Enable(mctx *ModuleContext) RegisterFunc
}

func (m *ModuleContext) RuntimeWarning(err error) {
	m.engine.cfg.RuntimeWarning(err)
}

func (m *ModuleContext) NewValue(v interface{}) goja.Value {
	return m.engine.vm.ToValue(v)
}
